/*
 * MainFrame.java
 *
 * Created on 12 February 2007, 11:27
 *
 * www.starjar.com
 *             +
 *     +       *       +
 *       *     *     *
 *         *   *   *
 *           * * *
 *   - * * * * * * * * * -
 *           * * *
 *         *   *   *
 *       *     *     *
 *     +       *       +
 *             +
 *
 *     SSSS  TTTTTTT    A     RRRRR   JJJJJJJ    A     RRRRR
 *    S    S    T      A A    R    R     J      A A    R    R
 *    S         T     A   A   R    R     J     A   A   R    R
 *      SSS     T    A     A  RRRRR      J    A     A  RRRRR
 *         S    T   AAAAAAAAA R   R      J   AAAAAAAAA R   R
 *    S    S    T   A       A R    R  J  J   A       A R    R  ..
 *     SSS      T   A       A R    R   JJJ   A       A R    R  ..
 *
 * Copyright (c) 2007 Peter Henderson. All Rights Reserved.
 */

package breakglassfishstandaloneclient;

import breakglassfishslowinitial.BreakSessionRemote;
import java.lang.reflect.Method;
import javax.naming.Context;
import javax.naming.InitialContext;

/**
 *
 * Launch via web start from the command line
 * javaws http://peter-laptop:8080/BreakGlassfishSlowInitialContext-war/BreakGlassfishStandAloneClient.jnlp
 *
 * @author  peter
 */
public class MainFrame extends javax.swing.JFrame {
    
    /** Creates new form MainFrame */
    public MainFrame() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jButton1 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        jButton1.setText("Press Me");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .addComponent(jButton1))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 245, Short.MAX_VALUE)
                .addContainerGap())
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-400)/2, (screenSize.height-300)/2, 400, 300);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed

        String homeDir = System.getProperty("user.home") + "/Starjar/BreakGlassfishSlowInitialContext";
        String securityFile = homeDir + "/appclientlogin.conf";
        
        // Create a magic local file for the crappy security
        // without this programattic login fails.
        InstallUtils.installFile("appclientlogin.conf", securityFile, null);
        System.setProperty( "java.security.auth.login.config", securityFile);
        

        // over ride the web start property for the server address
        //System.setProperty("org.omg.CORBA.ORBInitialHost", "starjar-partech");
        System.out.println( "org.omg.CORBA.ORBInitialHost = " + System.getProperty("org.omg.CORBA.ORBInitialHost"));
        
        Context initial = null;
        try {
            long start = System.currentTimeMillis();
            initial = new InitialContext();
            long dur = System.currentTimeMillis() - start;
            System.out.println("Took " + dur + " ms to get initial context.");
            jTextArea1.setText("Took " + dur + " ms to get initial context.");
            
            // application is using the Glassfish admin realm. (admin-realm)
            // see sun-application.xml
            login("admin", "adminadmin");
            
            BreakSessionRemote sessionBean = (BreakSessionRemote)initial.lookup("breakglassfishslowinitial.BreakSessionRemote");
            
            System.out.println("Caling Business method");
            String res = sessionBean.businessMethod("Hello");
            System.out.println("Business method returned " + res);
            jTextArea1.setText(jTextArea1.getText() + "\n" + "Business method returned " + res);
            
            
        } catch(Exception e) {
            e.printStackTrace();
        }
    }//GEN-LAST:event_jButton1ActionPerformed
    
    
    /**
     * Perform programmatic login to Glassfish Server.
     *
     *
     */
    @SuppressWarnings("unchecked")
    public static boolean login(String uid, String pwd) {
        boolean loginOk = false;

        try {
            Class clz = Class.forName("com.sun.appserv.security.ProgrammaticLogin");
            Method loginMethod = clz.getMethod("login", String.class, String.class);
            Method logoutMethod = clz.getMethod("logout");
            
            Object loginApi = clz.newInstance();
            
            System.out.println("About to invoke Login");
            Object result = loginMethod.invoke(loginApi, uid, pwd);
            System.out.println("Login called OK. login result = " + result);
            
            //Method[] meths = clz.getMethods();
            //for( int i=0; i<meths.length; i++) {
            //    System.out.println("Meth[" + i + "] = " + meths[i].getName() );
            //}
            
            loginOk = true;
            
        } catch(Exception e) {
            e.printStackTrace();
        }
        return loginOk;
    }
    
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        // Need todo this or WebStart version fails with a nasty ORB exception
        // even though we asked for full permissions.
        System.out.println("killing the security manager");
        System.setSecurityManager(null);        
        
        
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrame().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    // End of variables declaration//GEN-END:variables
    
}
